"""
 A Class Representing an Edge in a Directed Graph
 
 Author: Ben Kybartas
 Student ID: 260477933
 Date: April 10, 2012
"""

class Edge:

	"""The initialization function
	
	Args:
		name (str): The name of our edge
		
	Kwargs:
		from_node (Node): The node from which the edge originates
		to_node (Node): The node to which the edge points
	"""
	def __init__(self, name, from_node=None, to_node=None):
		
		self._name = name
		self._from_node = from_node
		self._to_node = to_node
		
	"""Get the name of our edge

	Returns:
		(str): The name of the edge
	"""
	def get_name(self):
		return self._name
		
	"""Set the name of our edge

	Args:
		new_name(str): The new name of the edge
	"""
	def set_name(self, new_name):
		self._name = new_name	
		
	"""Get our from node

	Returns:
		(Node): The node from which the edge originates
	"""
	def get_from_node(self):
		return self._from_node
		
	"""Set our from node

	Args:
		new_from_node(Node): The new node from which the edge originates
	"""
	def set_from_node(self, new_from_node):
		self._from_node = new_from_node	
		
	"""Get our to node

	Returns:
		(Node): The node to which the edge points
	"""
	def get_to_node(self):
		return self._to_node
		
	"""Set our from node

	Args:
		new_to_node(Node): The new node to which the edge points
	"""
	def set_to_node(self, new_to_node):
		self._to_node = new_to_node	

	"""Check if our name equals another edge name
	
	Param:
		name (str): The name we are comparing
	Returns:
		(Bool): If its equal or not
	"""
	
	def name_equals(self, name):
		
		#Do a basic check
		equals = self._name == name
		
		#Check for the N/A case, where we don't care about names		
		for attr in self._name:
			if attr in name:
				if self._name[attr] == "N/A" or name[attr] == "N/A":
					equals = True
		return equals

