"""

The Main File

By: Ben Kybartas
Student ID: 260477933
"""

from Node import *
from StoryNode import *
from Edge import *
from Graph import *
from SocialGraph import *
from StoryGraph import *
from RewriteRule import *
from Scheduler import *

#-------------------------------------------#
#		    Create our Graph! 				#
#-------------------------------------------#
Alice = Node("Alice", {"alive" : True})
Bob = Node("Bob", {"alive" : True})
Charles = Node("Charles", {"alive" : True})
Player = Node("Player", {})
main_graph = SocialGraph("Mini_World", [Alice, Bob, Charles, Player])

main_graph.connect(Alice, {"Loves" : "Money"}, Bob)
main_graph.connect(Charles, {"Hates" : "Personality"}, Bob)
main_graph.set_player(Player)

# ------------------------------------------ #
#              DEADLY MURDER!                #
# ------------------------------------------ #

#----------------------------------
# Game World Condition
#----------------------------------
C = Node("Invoker", {"alive" : True})
D = Node("Victim", {"alive" : True})

Murder = Graph("Murder", [C, D])
Murder.connect(C, {"Hates": "N/A"}, D)
#----------------------------------
# Game World Outcomes
#----------------------------------

# Kill Victim
target = Node("Victim", {"alive" : False})
Kill_Modification = Graph("Kill_Modification", [target])

#----------------------------------
# Story Results
#----------------------------------
One = StoryNode("Murder_Request_from_Invoker", {"Node_Type" : "Info"}, C)
Two = StoryNode("Go_To_Victim", {"Node_Type" : "Go_To"}, D)
Three = StoryNode("Kill_Victim", {"Node_Type" : "Murder"}, D)
Three.set_modification(Kill_Modification)
Four = StoryNode("Return_to_Invoker", {"Node_Type" : "Return"}, C)

Murder_Story = StoryGraph("Murder_Story", [One, Two, Three, Four])
Murder_Story.connect(One, {}, Two)
Murder_Story.connect(Two, {}, Three)
Murder_Story.connect(Three, {}, Four)
Murder_Rule = RewriteRule(None, Murder, Murder_Story, None)

# ------------------------------------------ #
#                 THIEVERY!                  #
# ------------------------------------------ #

#----------------------------------
# Game World Condition
#----------------------------------
A = Node("Victim", {"alive" : True})
B = Node("Object", {"status" : "owned"})
Steal_Social_Condition = Graph("Steal_Social_Condition", [A, B])
Steal_Social_Condition.connect(A, {"Owns": "N/A"}, B)

#----------------------------------
# Game World Outcomes
#----------------------------------

# Kill Victim
target = Node("Object", {"status" : "stolen"})
Steal_Modification = Graph("Steal_Modification", [target])

#----------------------------------
# Story Rule
#----------------------------------
One = StoryNode("Stalk_Victim", {"Node_Type" : "Info"}, A)
Two = StoryNode("Go_To_Victim", {"Node_Type" : "Go_To"}, A)
Three = StoryNode("Steal_Object", {"Node_Type" : "Steal"}, B)
Three.set_modification(Steal_Modification)
Four = StoryNode("Leave_Victim", {"Node_Type" : "Return"}, A)

Steal_Story = StoryGraph("Steal_Story", [One, Two, Three, Four])
Steal_Story.connect(One, {}, Two)
Steal_Story.connect(Two, {}, Three)
Steal_Story.connect(Three, {}, Four)

Steal_Rule = RewriteRule(None, Steal_Social_Condition, Steal_Story, None)

# ------------------------------------------ #
#         SUPRISING TWISTS: AMBUSH!          #
# ------------------------------------------ #

#----------------------------------
# Social Condition
#----------------------------------
Lover = Node("Lover", {"alive" : True})
Target = Node("Victim", {"alive" : False})

Ambush_Social_Condition = Graph("Ambush_Social_Condition", [Target, Lover])
Ambush_Social_Condition.connect(Lover, {"Loves" : "N/A"}, Target)
#----------------------------------
# Social Modification
#----------------------------------
Ambush_Modification = Node("Lover", {"alive" : False})
Ambush_Modification = Graph("Ambush_Modification", [Ambush_Modification])
#----------------------------------
# Story Condition
#----------------------------------
Murder = StoryNode("Kill_Victim", {"Node_Type" : "Murder"}, Target)
Ambush_Story_Condition = StoryGraph("Ambush_Story_Condition", [Murder])
#----------------------------------
# Story Outcome
#----------------------------------
Ambush = StoryNode("Ambush_By_Lover", {"Node_Type" : "Murder"}, Lover)
Ambush.set_modification(Ambush_Modification)
Ambush_Story_Outcome = StoryGraph("Ambush_Story_Outcome", [Murder, Ambush])
Ambush_Story_Outcome.connect(Murder, {}, Ambush)

Ambush_Rule = RewriteRule(Ambush_Story_Condition, Ambush_Social_Condition, Ambush_Story_Outcome, None)

"""
	Run our Simulation
"""
main_graph.plot('starting_social_graph')
sched = Scheduler(main_graph, [Steal_Rule, Murder_Rule], [], [])
run = True
numofstories = 0
while run:
	success = sched.initialize_narrative()
	if success:
		sched.write_narrative()
		numofstories += 1
	else:
		run = False
print numofstories
		
main_graph.plot('ending_social_graph')
