"""
 Represents a Rewrite Rule in our system

 By: Ben Kybartas
 Student ID: 260477933

"""

from Node import *
from Edge import *
from Graph import *

class RewriteRule:

	"""The initialization function
	
	Params:
		story_condition(StoryGraph): The condition (if any) of our narrative graph
		social_condition(SocialGraph): The condition (if any) of our game world graph
		story_outcome(StoryGraph): The outcome (if any) of our narrative graph
		social_outcome(SocialGraph): The outcome (if any) of our game world graph
	"""
	def __init__(self, story_condition, social_condition, story_modification, social_modification):
		self._story_condition = story_condition
		self._social_condition = social_condition
		self._story_modification = story_modification
		self._social_modification = social_modification

	"""Get the story condition"""
	def get_story_condition(self):
		return self._story_condition

	"""Get the social condition"""
	def get_social_condition(self):
		return self._social_condition
	
	"""Get the story modification"""
	def get_story_modification(self):
		return self._story_modification
	
	"""Get the social modification"""
	def get_social_modification(self):
		return self._social_modification
