"""
 A Directed Graph Object, tweaked for our narrative graph
 
 Author: Ben Kybartas
 Student ID: 260477933
 Date: April 10, 2012
"""

from Node import *
from Edge import *
from Graph import *

class StoryGraph(Graph):
	
	"""Get our starting story node
	
	Returns:
		Node: The starting node of our story
	"""
	def get_start_node(self):
		return self._nodes[0]
	
	"""Get our ending story node
	
	Returns:
		Node: The ending node of our story
	"""
	def get_end_node(self):
		return self._nodes[1]
	
	"""Add a new node to our graph
	
	Param:
		node (Node): The node to be added
	"""
	def add_new_node(self, node):
		
		#Make the new node
		new_node = Node(node.get_name(), node.get_attributes())
		
		#Add it to our graph
		self._nodes.append(new_node)
		
		#Redo our graph adjacency
		new_adj = zeros((len(self._nodes), len(self._nodes)))
		
		for row in range(len(self._adjacency)):
			for col in range(len(self._adjacency)):
				new_adj[row][col] = self._adjacency[row][col]
		self._adjacency = new_adj
